# -*- coding: utf-8 -*-
"""
Created on Mon Jun  7 12:14:18 2021

@author: hs-702
"""


# 1. 원본데이터 프레임을 복사 후 로지스틱회귀와 LGB 이용해서 정확도, 정밀도, 재현율, f1, roc_acu구하기기
# 2. corr( )함수를 이용해서 데이터간의 상관관계 계수를 구한 후 heatmap 그리기 (237pg 참고)
# 3 레이블 데이터와 상관계수의 절대값이 가장 높은 3개의 feature 데이터 구한 뒤 오름차순으로 sorting후 scatter
# 4. outliers의 인덱스를 제거하기


import pandas as pd
import numpy as np 
import matplotlib.pyplot as plt
import warnings
from sklearn.model_selection import train_test_split

from sklearn.metrics import confusion_matrix, accuracy_score, precision_score, recall_score, f1_score
from sklearn.metrics import roc_auc_score
from sklearn.linear_model import LogisticRegression
from lightgbm import LGBMClassifier
import seaborn as sns
from imblearn.over_sampling import SMOTE


card_df=pd.read_csv('C:/Users/hs-702/Desktop/veroro/archive/creditcard.csv')
card_df.info()
card_df.describe()


# 로지스틱회귀와 LGB의 정확도, 정밀도, 재현율, F1, AUC 값 구하기 (for문 활용: 174pg, 265pg, 338pg 참고)

def get_clf_eval(y_test, pred=None, pred_proba=None): #None은 기본값인데 변수에 들어가면 적용이 되고 그렇지 않으면 적용되지않는다
    accuracy = accuracy_score(y_test, pred)
    precision = precision_score(y_test, pred)
    recall = recall_score(y_test, pred)
    f1 = f1_score(y_test, pred)
    roc_auc = roc_auc_score(y_test, pred_proba) 
    print('정확도: {0:.4f}, 정밀도: {1:.4f}, 재현율: {2:.4f}, F1: {3:.4f}, AUC:{4:.4f}'.format(accuracy, precision, recall, f1, roc_auc))


def get_train(abc, X_train, y_train, X_test , y_test) : #아래 for문에 4개의 변수는 get_train에 차례대로 들어간다
    abc.fit(X_train, y_train)  # => lr_clf.fit(X_train, y_train)와 lgb_clf.fit(X_train, y_train) 
    pred = abc.predict(X_test)
    pred_proba = abc.predict_proba(X_test)[:,1]
    print(abc.__class__.__name__)
    get_clf_eval(y_test, pred, pred_proba)

print(card_df['Class'].value_counts())

X=card_df.drop('Time', axis=1)
X = X.iloc[:, :-1]
y = card_df.iloc[:, -1]


X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2, random_state=156, stratify = y)

lr_clf=LogisticRegression()
lgb_clf=LGBMClassifier()


estimators= [lr_clf, lgb_clf]
for x in estimators:
    get_train(x, X_train, y_train, X_test, y_test) # get_train의 4개의 변수가 차례대로 45줄에도 들어간다


# corr( )함수를 이용해서 데이터간의 상관관계 계수를 구한 후 heatmap 그리기 (273pg 참고)
import matplotlib.pyplot as plt
plt.figure(figsize=(9,9))
corr= card_df.corr()
sns.heatmap(corr, cmap='RdBu')

'''
# 레이블 데이터와 상관계수의 절대값이 가장 높은 3개의 feature 데이터 구한 뒤 오름차순으로 sorting후 scatter
plt.scatter(x=, y)
plt.ylabel('', fontsize=15)
plt.xlabel('', fontsize=15)
plt.show()

# outliers의 인덱스를 제거하기
'''